module OrdinaryDiffEqExplicitRK

import OrdinaryDiffEqCore: alg_order, alg_adaptive_order, alg_stability_size,
    OrdinaryDiffEqAdaptiveAlgorithm,
    @cache, alg_cache, OrdinaryDiffEqConstantCache,
    unwrap_alg,
    OrdinaryDiffEqMutableCache, initialize!, perform_step!, isfsal,
    CompositeAlgorithm, calculate_residuals!, calculate_residuals,
    full_cache, get_fsalfirstlast,
    _ode_interpolant, _ode_interpolant!,
    _ode_addsteps!, copyat_or_push!,
    DerivativeOrderNotPossibleError
using TruncatedStacktraces: @truncate_stacktrace
using RecursiveArrayTools, FastBroadcast, MuladdMacro, DiffEqBase
import LinearAlgebra: norm
import OrdinaryDiffEqCore

using Reexport
@reexport using SciMLBase

include("algorithms.jl")
include("alg_utils.jl")
include("explicit_rk_caches.jl")
include("explicit_rk_perform_step.jl")
include("inter_func.jl")
include("interpolants.jl")

export ExplicitRK

end

using Pkg
Pkg.add("AllocCheck")

using OrdinaryDiffEqExplicitRK
using OrdinaryDiffEqCore
using SciMLBase: FullSpecialize
using AllocCheck
using Test

"""
Allocation tests for OrdinaryDiffEqExplicitRK solvers using AllocCheck.jl.
Tests perform_step! directly (the core stepping function) rather than step!,
since step! includes saving operations that naturally allocate.
Uses FullSpecialize to avoid FunctionWrappers dynamic dispatch noise.
"""

@testset "ExplicitRK Allocation Tests" begin
    function simple_system!(du, u, p, t)
        du[1] = -0.5 * u[1]
        du[2] = -1.5 * u[2]
    end

    # Use FullSpecialize to avoid FunctionWrappers dynamic dispatch noise
    prob = ODEProblem{true, FullSpecialize}(simple_system!, [1.0, 1.0], (0.0, 1.0))

    explicit_rk_solvers = [ExplicitRK()]

    @testset "ExplicitRK perform_step! Static Analysis" begin
        for solver in explicit_rk_solvers
            @testset "$(typeof(solver)) perform_step! allocation check" begin
                integrator = init(
                    prob, solver, dt = 0.1, save_everystep = false,
                    abstol = 1.0e-6, reltol = 1.0e-6
                )
                step!(integrator)

                cache = integrator.cache
                allocs = check_allocs(
                    OrdinaryDiffEqCore.perform_step!,
                    (typeof(integrator), typeof(cache))
                )

                @test length(allocs) == 0

                if length(allocs) > 0
                    println(
                        "AllocCheck found $(length(allocs)) allocation sites in $(typeof(solver)) perform_step!"
                    )
                else
                    println(
                        "$(typeof(solver)) perform_step! appears allocation-free with AllocCheck"
                    )
                end
            end
        end
    end
end

using SafeTestsets

const TEST_GROUP = get(ENV, "ODEDIFFEQ_TEST_GROUP", "ALL")

@time @safetestset "Generic RK Tests" include("interpolation_tests.jl")

# Run QA tests (JET, Aqua, AllocCheck)
if TEST_GROUP != "Core" && isempty(VERSION.prerelease)
    @time @safetestset "JET Tests" include("jet.jl")
    @time @safetestset "Aqua" include("qa.jl")
    @time @safetestset "Allocation Tests" include("allocation_tests.jl")
end

using Pkg
Pkg.add("JET")

import OrdinaryDiffEqExplicitRK
using OrdinaryDiffEqExplicitRK
using OrdinaryDiffEqCore
using JET
using Test

@testset "JET Tests" begin
    # Test package for typos - now passing
    test_package(
        OrdinaryDiffEqExplicitRK, target_modules = (OrdinaryDiffEqExplicitRK,), mode = :typo
    )

    # Test individual solver type stability
    @testset "Solver Type Stability Tests" begin
        # Test problem
        function simple_system!(du, u, p, t)
            du[1] = -0.5 * u[1]
            du[2] = -1.5 * u[2]
        end
        prob = ODEProblem(simple_system!, [1.0, 1.0], (0.0, 1.0))

        # Test all exported ExplicitRK solvers
        explicit_rk_solvers = [ExplicitRK()]

        for solver in explicit_rk_solvers
            @testset "$(typeof(solver)) type stability" begin
                try
                    @test_opt broken = true init(prob, solver, dt = 0.1, save_everystep = false, abstol = 1.0e-6, reltol = 1.0e-6)
                    integrator = init(prob, solver, dt = 0.1, save_everystep = false, abstol = 1.0e-6, reltol = 1.0e-6)
                    @test_opt broken = true step!(integrator)
                catch e
                    @test_broken false # Mark as broken if solver fails to initialize
                    println("$(typeof(solver)) failed with: $e")
                end
            end
        end
    end
end

@cache struct ExplicitRKCache{uType, rateType, uNoUnitsType, TabType} <:
    OrdinaryDiffEqMutableCache
    u::uType
    uprev::uType
    tmp::uType
    utilde::rateType
    atmp::uNoUnitsType
    fsalfirst::rateType
    fsallast::rateType
    kk::Vector{rateType}
    tab::TabType
end

get_fsalfirstlast(cache::ExplicitRKCache, u) = (cache.kk[1], cache.fsallast)

function alg_cache(
        alg::ExplicitRK, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    kk = Vector{typeof(rate_prototype)}(undef, 0)
    for i in 1:(alg.tableau.stages)
        push!(kk, zero(rate_prototype))
    end
    fsalfirst = kk[1]
    if isfsal(alg.tableau)
        fsallast = kk[end]
    else
        fsallast = zero(rate_prototype)
    end
    utilde = zero(rate_prototype)
    tmp = zero(u)
    atmp = similar(u, uEltypeNoUnits)
    recursivefill!(atmp, false)
    tab = ExplicitRKConstantCache(alg.tableau, rate_prototype)
    return ExplicitRKCache(u, uprev, tmp, utilde, atmp, fsalfirst, fsallast, kk, tab)
end

struct ExplicitRKConstantCache{MType, VType, KType, BType, BiType} <:
    OrdinaryDiffEqConstantCache
    A::MType
    c::VType
    α::VType
    αEEst::VType
    stages::Int
    kk::KType
    B_interp::BType
    bi::BiType  # Pre-allocated buffer for interpolation polynomial weights
end

function ExplicitRKConstantCache(tableau, rate_prototype)
    (; A, c, α, αEEst, stages) = tableau
    A = copy(A') # Transpose A to column major looping
    kk = Array{typeof(rate_prototype)}(undef, stages) # Not ks since that's for integrator.opts.dense
    αEEst = isempty(αEEst) ? αEEst : α .- αEEst
    B_interp = hasproperty(tableau, :B_interp) ? tableau.B_interp : nothing
    bi = if isnothing(B_interp)
        nothing
    else
        Vector{eltype(B_interp)}(undef, size(B_interp, 1))
    end
    return ExplicitRKConstantCache(A, c, α, αEEst, stages, kk, B_interp, bi)
end

function alg_cache(
        alg::ExplicitRK, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return ExplicitRKConstantCache(alg.tableau, rate_prototype)
end

function initialize!(integrator, cache::ExplicitRKConstantCache)
    integrator.kshortsize = 2
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    integrator.k[1] = integrator.fsalfirst
    return integrator.k[2] = integrator.fsallast
end

@muladd function perform_step!(
        integrator, cache::ExplicitRKConstantCache,
        repeat_step = false
    )
    (; t, dt, uprev, u, f, p) = integrator
    alg = unwrap_alg(integrator, false)
    (; A, c, α, αEEst, stages) = cache
    (; kk) = cache

    # Calc First
    kk[1] = integrator.fsalfirst

    # Calc Middle
    for i in 2:(stages - 1)
        utilde = zero(kk[1])
        for j in 1:(i - 1)
            utilde = utilde + A[j, i] * kk[j]
        end
        kk[i] = f(uprev + dt * utilde, p, t + c[i] * dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    end

    #Calc Last
    utilde_last = zero(kk[1])
    for j in 1:(stages - 1)
        utilde_last = utilde_last + A[j, end] * kk[j]
    end
    u_beforefinal = uprev + dt * utilde_last
    kk[end] = f(u_beforefinal, p, t + c[end] * dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.fsallast = kk[end] # Uses fsallast as temp even if not fsal

    # Accumulate Result
    accum = α[1] * kk[1]
    for i in 2:stages
        accum = accum + α[i] * kk[i]
    end
    u = uprev + dt * accum

    if integrator.alg isa CompositeAlgorithm
        # Hairer II, page 22 modified to use Inf norm
        n = maximum(abs.((kk[end] .- kk[end - 1]) / (u .- u_beforefinal)))
        integrator.eigen_est = integrator.opts.internalnorm(n, t)
    end

    if integrator.opts.adaptive
        utilde = αEEst[1] .* kk[1]
        for i in 2:stages
            utilde = utilde + αEEst[i] * kk[i]
        end
        atmp = calculate_residuals(
            dt * utilde, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end

    if !isfsal(alg.tableau)
        integrator.fsallast = f(u, p, t + dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    end

    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.u = u
end

function initialize!(integrator, cache::ExplicitRKCache)
    integrator.kshortsize = 2
    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    return OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

@generated function accumulate_explicit_stages!(
        out, A, uprev, kk, dt, ::Val{s},
        ::Val{r} = Val(s)
    ) where {s, r}
    if s == 1
        return :(@muladd @.. broadcast = false out = uprev + dt * kk[1])
    elseif s == 2
        # Note that `A` is transposed
        return :(@muladd @.. broadcast = false out = uprev + dt * (A[1, $r] * kk[1]))
    else
        expr = :(
            @muladd @.. broadcast = false out = uprev +
                dt * (A[1, $r] * kk[1] + A[2, $r] * kk[2])
        )
        acc = expr.args[end].args[end].args[end].args[end].args[end].args
        for i in 3:(s - 1)
            push!(acc, :(A[$i, $r] * kk[$i]))
        end
        return expr
    end
end

@generated function accumulate_EEst!(out, αEEst, kk, dt, ::Val{s}) where {s}
    if s == 1
        return :(@muladd @.. broadcast = false out = dt * (αEEst[1] * kk[1]))
    else
        expr = :(@muladd @.. broadcast = false out = dt * (αEEst[1] * kk[1] + αEEst[2] * kk[2]))
        acc = expr.args[end].args[end].args[end].args[end].args
        for i in 3:s
            push!(acc, :(αEEst[$i] * kk[$i]))
        end
        return expr
    end
end

function accumulate_EEst!(out, αEEst, utilde, kk, dt, stages)
    @.. broadcast = false utilde = αEEst[1] * kk[1]
    for i in 2:stages
        @.. broadcast = false utilde = utilde + αEEst[i] * kk[i]
    end
    return @.. broadcast = false out = dt * utilde
end

@muladd function compute_stages!(
        f::F, A, c, utilde, u, tmp, uprev, kk, p, t, dt,
        stages::Integer
    ) where {F}
    # Middle
    for i in 2:(stages - 1)
        @.. broadcast = false utilde = zero(kk[1][1])
        for j in 1:(i - 1)
            @.. broadcast = false utilde = utilde + A[j, i] * kk[j]
        end
        @.. broadcast = false tmp = uprev + dt * utilde
        f(kk[i], tmp, p, t + c[i] * dt)
    end

    #Last
    @.. broadcast = false utilde = zero(kk[1][1])
    for j in 1:(stages - 1)
        @.. broadcast = false utilde = utilde + A[j, end] * kk[j]
    end
    @.. broadcast = false u = uprev + dt * utilde
    f(kk[end], u, p, t + c[end] * dt) #fsallast is tmp even if not fsal
    return nothing
end

@generated function compute_stages!(
        f::F, A, c, u, tmp, uprev, kk, p, t, dt,
        ::Val{s}
    ) where {F, s}
    return quote
        Base.@nexprs $(s - 2) i′ -> begin
            i = i′ + 1
            accumulate_explicit_stages!(tmp, A, uprev, kk, dt, Val(i))
            f(kk[i], tmp, p, t + c[i] * dt)
        end
        accumulate_explicit_stages!(u, A, uprev, kk, dt, Val(s))
        f(kk[s], u, p, t + c[end] * dt)
    end
end

function runtime_split_stages!(
        f::F, A, c, utilde, u, tmp, uprev, kk, p, t, dt,
        stages::Integer
    ) where {F}
    return Base.@nif 17 (s -> (s == stages)) (
        s -> compute_stages!(
            f, A, c, u, tmp, uprev, kk, p, t,
            dt, Val(s)
        )
    ) (
        s -> compute_stages!(
            f,
            A,
            c,
            utilde,
            u,
            tmp,
            uprev,
            kk,
            p,
            t,
            dt,
            stages
        )
    )
end

function accumulate_fsal!(u, α, utilde, uprev, kk, dt, stages)
    @.. broadcast = false utilde = α[1] * kk[1]
    for i in 2:stages
        @.. broadcast = false utilde = utilde + α[i] * kk[i]
    end
    return @.. broadcast = false u = uprev + dt * utilde
end

function runtime_split_fsal!(out, A, utilde, uprev, kk, dt, stages)
    return Base.@nif 17 (s -> (s == stages)) (
        s -> accumulate_explicit_stages!(
            out, A, uprev, kk, dt,
            Val(s + 1), Val(1)
        )
    ) (
        s -> accumulate_fsal!(
            out,
            A,
            utilde,
            uprev,
            kk,
            dt,
            stages
        )
    )
end

function runtime_split_EEst!(tmp, αEEst, utilde, kk, dt, stages)
    return Base.@nif 17 (s -> (s == stages)) (s -> accumulate_EEst!(tmp, αEEst, kk, dt, Val(s))) (
        s -> accumulate_EEst!(
            tmp,
            αEEst,
            utilde,
            kk,
            dt,
            stages
        )
    )
end

@muladd function perform_step!(integrator, cache::ExplicitRKCache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    alg = unwrap_alg(integrator, false)
    # αEEst is `α - αEEst`
    (; A, c, α, αEEst, stages) = cache.tab
    (; kk, utilde, tmp, atmp) = cache

    runtime_split_stages!(f, A, c, utilde, u, tmp, uprev, kk, p, t, dt, stages)
    integrator.stats.nf += stages - 1

    #Accumulate
    if !isfsal(alg.tableau)
        runtime_split_fsal!(u, α, utilde, uprev, kk, dt, stages)
    end

    if integrator.alg isa CompositeAlgorithm
        # Hairer II, page 22 modified to use Inf norm
        @.. broadcast = false utilde = abs((kk[end] - kk[end - 1]) / (u - tmp))
        integrator.eigen_est = integrator.opts.internalnorm(norm(utilde, Inf), t)
    end

    if integrator.opts.adaptive
        runtime_split_EEst!(tmp, αEEst, utilde, kk, dt, stages)
        calculate_residuals!(
            atmp, tmp, uprev, u,
            integrator.opts.abstol, integrator.opts.reltol,
            integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end

    if !isfsal(alg.tableau)
        f(integrator.fsallast, u, p, t + dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    end
end

# ============================================================================
# Generic RK interpolation utilities
# ============================================================================

@inline function falling_factorial(n::Integer, k::Integer)
    result = one(n)
    for j in 0:(k - 1)
        result *= (n - j)
    end
    return result
end

"""
    eval_poly_derivative(Θ, coeffs, order::Int)

Evaluate the k-th derivative of a polynomial at Θ using Horner's method.
coeffs[j] is the coefficient of Θ^(j-1).
"""
@inline function eval_poly_derivative(Θ, coeffs, order::Int)
    n = length(coeffs)
    if n <= order
        return zero(eltype(coeffs)) * zero(Θ)
    end

    if order == 0
        result = coeffs[n]
        for i in (n - 1):-1:1
            result = muladd(Θ, result, coeffs[i])
        end
        return result
    else
        result = coeffs[n] * falling_factorial(n - 1, order)
        for j in (n - 1):-1:(order + 1)
            multiplier = falling_factorial(j - 1, order)
            result = muladd(Θ, result, coeffs[j] * multiplier)
        end
        return result
    end
end

"""
    generic_rk_interpolant(Θ, dt, y₀, k, B_interp; idxs=nothing, order=0)

Generic interpolation for Runge-Kutta methods using the B_interp coefficient matrix.
"""
function generic_rk_interpolant(Θ, dt, y₀, k, B_interp, bi; idxs = nothing, order = 0)
    if isnothing(B_interp)
        throw(DerivativeOrderNotPossibleError())
    end

    nstages = size(B_interp, 1)

    if isempty(k) || nstages == 0
        throw(DerivativeOrderNotPossibleError())
    end

    inv_dt_factor = order <= 1 ? one(dt) : inv(dt)^(order - 1)

    # Compute weights inline (Θ may be a ForwardDiff.Dual, so we cannot
    # store into the pre-allocated Float64 buffer here).
    b1 = eval_poly_derivative(Θ, @view(B_interp[1, :]), order)
    return if isnothing(idxs)
        interp_sum = k[1] * b1
        for i in 2:nstages
            bval = eval_poly_derivative(Θ, @view(B_interp[i, :]), order)
            interp_sum = interp_sum + k[i] * bval
        end
        if order == 0
            y₀ + dt * interp_sum
        else
            interp_sum * inv_dt_factor
        end
    else
        interp_sum = k[1][idxs] * b1
        for i in 2:nstages
            bval = eval_poly_derivative(Θ, @view(B_interp[i, :]), order)
            interp_sum = interp_sum + k[i][idxs] * bval
        end
        if order == 0
            y₀[idxs] + dt * interp_sum
        else
            interp_sum * inv_dt_factor
        end
    end
end

"""
    generic_rk_interpolant!(out, Θ, dt, y₀, k, B_interp; idxs=nothing, order=0)

In-place version of generic interpolation for Runge-Kutta methods.
"""
function generic_rk_interpolant!(out, Θ, dt, y₀, k, B_interp, bi; idxs = nothing, order = 0)
    if isnothing(B_interp)
        throw(DerivativeOrderNotPossibleError())
    end

    nstages = size(B_interp, 1)

    if isempty(k) || nstages == 0
        throw(DerivativeOrderNotPossibleError())
    end

    inv_dt_factor = order <= 1 ? one(dt) : inv(dt)^(order - 1)

    # Fill pre-allocated bi buffer with polynomial weights
    for i in 1:nstages
        bi[i] = eval_poly_derivative(Θ, @view(B_interp[i, :]), order)
    end

    if isnothing(idxs)
        if order == 0
            @.. out = y₀
            for i in 1:nstages
                @.. out += dt * k[i] * bi[i]
            end
        else
            @.. out = zero(eltype(out))
            for i in 1:nstages
                @.. out += k[i] * bi[i]
            end
            @.. out *= inv_dt_factor
        end
    else
        if order == 0
            @views @.. out = y₀[idxs]
            for i in 1:nstages
                @views @.. out += dt * k[i][idxs] * bi[i]
            end
        else
            @.. out = zero(eltype(out))
            for i in 1:nstages
                @views @.. out += k[i][idxs] * bi[i]
            end
            @.. out *= inv_dt_factor
        end
    end
    return out
end

function SciMLBase.interp_summary(
        ::Type{cacheType},
        dense::Bool
    ) where {cacheType <: Union{ExplicitRKCache, ExplicitRKConstantCache}}
    return dense ? "specialized RK interpolation" : "1st order linear"
end

using OrdinaryDiffEqExplicitRK
using OrdinaryDiffEqExplicitRK: constructTsit5ExplicitRK, constructDormandPrince
using OrdinaryDiffEqCore
using DiffEqBase
using Test
import SciMLBase

# ============================================================================
# Test Problems
# ============================================================================

f_linear(u, p, t) = 1.01 * u
prob_ode_linear = ODEProblem(
    ODEFunction(f_linear; analytic = (u0, p, t) -> u0 * exp(1.01t)),
    1 / 2, (0.0, 1.0)
)

function f_2Dlinear!(du, u, p, t)
    du[1] = 1.01 * u[1]
    return du[2] = 1.01 * u[2]
end
prob_ode_2Dlinear = ODEProblem(
    ODEFunction(f_2Dlinear!; analytic = (u0, p, t) -> u0 .* exp(1.01t)),
    [1 / 2, 1 / 2], (0.0, 1.0)
)

# ============================================================================
# Basic Solve Tests
# ============================================================================

@testset "Basic Solve" begin
    for tableau_fn in [constructTsit5ExplicitRK, constructDormandPrince]
        sol = solve(prob_ode_linear, ExplicitRK(tableau = tableau_fn()))
        @test length(sol) < 20
        @test SciMLBase.successful_retcode(sol)

        sol = solve(prob_ode_2Dlinear, ExplicitRK(tableau = tableau_fn()))
        @test length(sol) < 20
        @test SciMLBase.successful_retcode(sol)
    end
end

# ============================================================================
# Interpolation Tests
# ============================================================================

@testset "Interpolation" begin
    f_decay(u, p, t) = -u
    prob_interp = ODEProblem(
        ODEFunction(f_decay; analytic = (u0, p, t) -> exp(-t)), 1.0, (0.0, 1.0)
    )

    sol = solve(prob_interp, ExplicitRK(tableau = constructTsit5ExplicitRK()), dense = true)
    @test SciMLBase.successful_retcode(sol)
    @test sol(0.0) ≈ 1.0 atol = 1.0e-8
    @test sol(0.5) ≈ exp(-0.5) atol = 0.1
    @test sol(1.0) ≈ exp(-1.0) atol = 0.1

    # Vector problem (in-place)
    function f_vec!(du, u, p, t)
        du[1] = -u[1]
        du[2] = -2 * u[2]
    end
    exact_vec(t) = [exp(-t), exp(-2t)]
    prob_vec = ODEProblem(
        ODEFunction(f_vec!; analytic = (u0, p, t) -> exact_vec(t)),
        [1.0, 1.0], (0.0, 1.0)
    )

    sol = solve(prob_vec, ExplicitRK(tableau = constructTsit5ExplicitRK()), dense = true)
    @test SciMLBase.successful_retcode(sol)
    @test sol(0.5) ≈ exact_vec(0.5) atol = 0.1

    # Interpolation with idxs
    @test sol(0.5, idxs = 1) ≈ exp(-0.5) atol = 0.1
    @test sol(0.5, idxs = 2) ≈ exp(-1.0) atol = 0.1
    @test sol(0.5, idxs = [1, 2]) ≈ exact_vec(0.5) atol = 0.1
end

# ============================================================================
# L2 Convergence Order Tests
# ============================================================================

function compute_midstep_error(sol, exact_fn)
    max_err = 0.0
    for i in 1:(length(sol.t) - 1)
        t_mid = (sol.t[i] + sol.t[i + 1]) / 2
        interp_val = sol(t_mid)
        exact_val = exact_fn(t_mid)
        if interp_val isa Number
            err = abs(interp_val - exact_val)
        else
            err = maximum(abs.(interp_val .- exact_val))
        end
        max_err = max(max_err, err)
    end
    return max_err
end

function estimate_order(errors, dts)
    orders = Float64[]
    for i in 2:length(errors)
        order = log(errors[i - 1] / errors[i]) / log(dts[i - 1] / dts[i])
        push!(orders, order)
    end
    return orders
end

@testset "L2 Convergence - Scalar" begin
    f_conv(u, p, t) = -u
    exact_scalar(t) = exp(-t)
    prob_conv = ODEProblem(
        ODEFunction(f_conv; analytic = (u0, p, t) -> exact_scalar(t)), 1.0, (0.0, 1.0)
    )

    tableau = constructTsit5ExplicitRK()
    dts = [1 / 2^k for k in 2:6]
    errors = Float64[]

    for dt in dts
        sol = solve(
            prob_conv, ExplicitRK(tableau = tableau); dt = dt, adaptive = false, dense = true
        )
        push!(errors, compute_midstep_error(sol, exact_scalar))
    end

    orders = estimate_order(errors, dts)
    avg_order = sum(orders) / length(orders)
    @test avg_order > 3.5
end

@testset "L2 Convergence - Vector" begin
    function f_conv_vec!(du, u, p, t)
        du[1] = -u[1]
        du[2] = -2 * u[2]
    end
    exact_vector(t) = [exp(-t), exp(-2t)]
    prob_conv_vec = ODEProblem(
        ODEFunction(f_conv_vec!; analytic = (u0, p, t) -> exact_vector(t)),
        [1.0, 1.0], (0.0, 1.0)
    )

    tableau = constructTsit5ExplicitRK()
    dts = [1 / 2^k for k in 2:6]
    errors = Float64[]

    for dt in dts
        sol = solve(
            prob_conv_vec, ExplicitRK(tableau = tableau); dt = dt, adaptive = false, dense = true
        )
        err = compute_midstep_error(sol, exact_vector)
        push!(errors, err)
    end

    orders = estimate_order(errors, dts)
    avg_order = sum(orders) / length(orders)
    @test avg_order > 3.5
end

"""
    Interpolants for ExplicitRK methods

Implements the dense output dispatches required by OrdinaryDiffEqCore for
ExplicitRKCache and ExplicitRKConstantCache.
"""

const ExplicitRKCacheTypes = Union{ExplicitRKCache, ExplicitRKConstantCache}

# ============================================================================
# _ode_addsteps! implementations
# ============================================================================

@muladd function _ode_addsteps!(
        k, t, uprev, u, dt, f, p, cache::ExplicitRKConstantCache,
        always_calc_begin = false, allow_calc_end = true,
        force_calc_end = false
    )
    # Only compute all stage vectors when B_interp is available for generic RK
    # interpolation. Without B_interp, the default Hermite addsteps suffices.
    isnothing(cache.B_interp) && return nothing

    (; A, c, stages) = cache

    if length(k) < stages || always_calc_begin
        copyat_or_push!(k, 1, f(uprev, p, t))

        for i in 2:stages
            utilde = uprev
            for j in 1:(i - 1)
                utilde = utilde + dt * A[j, i] * k[j]
            end
            copyat_or_push!(k, i, f(utilde, p, t + c[i] * dt))
        end
    end
    nothing
end

@muladd function _ode_addsteps!(
        k, t, uprev, u, dt, f, p, cache::ExplicitRKCache,
        always_calc_begin = false, allow_calc_end = true,
        force_calc_end = false
    )
    # Only compute all stage vectors when B_interp is available for generic RK
    # interpolation. Without B_interp, the default Hermite addsteps suffices.
    isnothing(cache.tab.B_interp) && return nothing

    (; kk, tmp, tab) = cache
    (; A, c, stages) = tab

    if length(k) < stages || always_calc_begin
        f(kk[1], uprev, p, t)
        copyat_or_push!(k, 1, kk[1])

        for i in 2:stages
            @.. broadcast = false tmp = uprev
            for j in 1:(i - 1)
                @.. broadcast = false tmp = tmp + dt * A[j, i] * kk[j]
            end
            f(kk[i], tmp, p, t + c[i] * dt)
            copyat_or_push!(k, i, kk[i])
        end
    end
    nothing
end

# ============================================================================
# _ode_interpolant implementations
# ============================================================================

# Fallback for unsupported derivative orders
function _ode_interpolant(
        Θ, dt, y₀, y₁, k,
        cache::ExplicitRKCacheTypes,
        idxs, T::Type{Val{D}}, differential_vars
    ) where {D}
    throw(DerivativeOrderNotPossibleError())
end

function _ode_interpolant!(
        out, Θ, dt, y₀, y₁, k,
        cache::ExplicitRKCacheTypes,
        idxs, T::Type{Val{D}}, differential_vars
    ) where {D}
    throw(DerivativeOrderNotPossibleError())
end

@inline function get_B_interp(cache::ExplicitRKConstantCache)
    return cache.B_interp
end

@inline function get_B_interp(cache::ExplicitRKCache)
    return cache.tab.B_interp
end

@inline function get_bi(cache::ExplicitRKConstantCache)
    return cache.bi
end

@inline function get_bi(cache::ExplicitRKCache)
    return cache.tab.bi
end

# Generate interpolant methods for derivative orders 0-3
# Only dispatch when B_interp is available; otherwise fall through to Hermite default.
for order in 0:3
    @eval begin
        @muladd function _ode_interpolant(
                Θ, dt, y₀, y₁, k,
                cache::ExplicitRKCacheTypes,
                idxs, T::Type{Val{$order}}, differential_vars
            )
            B_interp = get_B_interp(cache)
            if isnothing(B_interp)
                # Fall back to Hermite interpolation (the generic default)
                dv = OrdinaryDiffEqCore.interpolation_differential_vars(
                    differential_vars, y₀, idxs
                )
                return OrdinaryDiffEqCore.hermite_interpolant(
                    Θ, dt, y₀, y₁, k,
                    Val{cache isa OrdinaryDiffEqMutableCache},
                    idxs, T, dv
                )
            end
            bi = get_bi(cache)
            return generic_rk_interpolant(Θ, dt, y₀, k, B_interp, bi; idxs = idxs, order = $order)
        end

        @muladd function _ode_interpolant!(
                out, Θ, dt, y₀, y₁, k,
                cache::ExplicitRKCacheTypes,
                idxs, T::Type{Val{$order}}, differential_vars
            )
            B_interp = get_B_interp(cache)
            if isnothing(B_interp)
                # Fall back to Hermite interpolation (the generic default)
                dv = OrdinaryDiffEqCore.interpolation_differential_vars(
                    differential_vars, y₀, idxs
                )
                return OrdinaryDiffEqCore.hermite_interpolant!(
                    out, Θ, dt, y₀, y₁, k,
                    idxs, T, dv
                )
            end
            bi = get_bi(cache)
            return generic_rk_interpolant!(out, Θ, dt, y₀, k, B_interp, bi; idxs = idxs, order = $order)
        end
    end
end
